<template>
    <div class="list-view">
        <page-title>
            <el-button @click="addRow" type="primary" icon="el-icon-plus" :loading="downloading" class="filter-item">
                新增
            </el-button>
            <el-button @click="download" icon="el-icon-upload2" :loading="downloading" class="filter-item">
                导出
            </el-button>
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="workflow" label="流程" :formatter="workflowFormatter"> </el-table-column>
            <el-table-column prop="applicantUscc" label="申请人统一社会信用代码"> </el-table-column>
            <el-table-column prop="inventorIdno" label="第一发明人身份证"> </el-table-column>
            <el-table-column prop="deduction" label="是否请求费减"> </el-table-column>
            <el-table-column prop="essentialReview" label="是否请求实质审查"> </el-table-column>
            <el-table-column prop="publicInAdvance" label="是否申请提前公开"> </el-table-column>
            <el-table-column prop="chapterAcceptanceNotice" label="是否申请红章受理通知书"> </el-table-column>
            <el-table-column prop="chapterPaymentNotice" label="是否申请红章缴费通知书"> </el-table-column>
            <el-table-column prop="decideReply" label="是否决定答复">
                <template slot-scope="{ row }">
                    <el-tag :type="row.decideReply ? '' : 'info'">{{ row.decideReply }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="isClientReady" label="准备答复意见">
                <template slot-scope="{ row }">
                    <el-tag :type="row.isClientReady ? '' : 'info'">{{ row.isClientReady }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="replyPassed" label="是否通过答复">
                <template slot-scope="{ row }">
                    <el-tag :type="row.replyPassed ? '' : 'info'">{{ row.replyPassed }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="registerNotice" label="办登通知日"> </el-table-column>
            <el-table-column prop="registerEndDate" label="办登截止日"> </el-table-column>
            <el-table-column prop="feeRemark" label="费用备注"> </el-table-column>
            <el-table-column prop="payment" label="是否已缴费">
                <template slot-scope="{ row }">
                    <el-tag :type="row.payment ? '' : 'info'">{{ row.payment }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="annualFee" label="年费"> </el-table-column>
            <el-table-column prop="feePaymentPeriod" label="年费支付期限"> </el-table-column>
            <el-table-column prop="bill" label="账单"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'DomesticPatentList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/domesticPatent/all',
            downloading: false,
            workflowOptions: [
                { label: '待添加供应商', value: 'ADD_SUPPLIERS' },
                { label: '待提交供应商材料', value: 'SUPPLIER_MATERIALS' },
                { label: '待维护案件', value: 'MAINTAIN_CASE' },
                { label: '待审查', value: 'PENDING_REVIEW' },
                { label: '待办登', value: 'PENDING_REGISTER' },
                { label: '办理登记', value: 'REGISTER' },
                { label: '待维护年费信息', value: 'ANNUAL_FEE' },
                { label: '已完成', value: 'COMPLETED' }
            ]
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        workflowFormatter(row, column, cellValue, index) {
            let selectedOption = this.workflowOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return { search: this.search };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/domesticPatentEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/domesticPatentEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/domesticPatent/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/domesticPatent/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
